#include <bits/stdc++.h>
using namespace std;
using lint = long long;
using pi = array<int, 2>;
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(), (a).end()

// WA1: Value out of range
// WA2: u = v
// WA3: result is wrong
// WA4: query limit exceeded
extern vector<int> recover(int N, vector<int> U, vector<int> V);

namespace {
    
static const std::string input_secret = "a21b0d6d-585f-INPUT-93fe-7202aef2815b";
static const std::string pipe_secret = "ed561a6f-29fe-PIPE-a8cf-367142ee68e2";
static const std::string output_secret = "00daad08-86ae-OUTPUT-b142-47d36a7488d9";
static const std::string error_secret = "7b8ea5f1-1613-ERROR-89cf-53ab68910981";


void ensure(bool p, const char *err) {
	if (!p) {
		cout << error_secret << "\n";
		cout << err << endl;
		exit(0);
	}
}
int n;
vector<int> rev;
auto rng = mt19937(0x19057235);
long long cmpcnt;
}

int compare(int u, int v) {
	ensure(0 <= u && u < n, "Wrong Answer [1]");
	ensure(0 <= v && v < n, "Wrong Answer [1]");
	ensure(u != v, "Wrong Answer [2]");
	cmpcnt++;
	return rev[u] < rev[v];
}
namespace {

vector<vector<int>> gph;
vector<int> cnt;
vector<int> pcnt; //소수만 세기
vector<vector<int>> dv; //소인수를 저장
vector<vector<int>> pv; //소인수분해를 해서 소인수를 제곱된 횟수만큼 저장

int dfs(int x) {
	int tot = 0;
	for (auto &y : gph[x]) {
		int sz = dfs(y);
		cnt[sz]--;
		tot += sz;
	}
	cnt[tot]++;
	return tot + 1;
}

double sc=100;

void Go() {
	// internally, edges are given in permutation order
	cin >> n;
	rev.clear();
	rev.resize(n);
	cnt.clear();
	cnt.resize(n+1);
	gph.clear();
	gph.resize(n);
	dv.clear();
	dv.resize(n+1);
	pv.clear();
	pv.resize(n+1);
	pcnt.clear();
	pcnt.resize(n+1);
	for(int i=2;i<=n;i++) {
	    bool isprime=(dv[i].empty());
	    if (isprime) {
    	    for(int j=i;j<=n;j+=i) {
    	        dv[j].push_back(i);
    	    }
	    }
	}
	for(int i=1;i<=n;i++) {
	    int now=i;
	    for(int x:dv[i]) {
	        while (now%x==0) {
	            pv[i].push_back(x);
	            now/=x;
	        }
	    }
	}
	vector<int> par(n);
	vector<pi> edges;
	for (int i = 1; i < n ; i++) {
		cin >> par[i];
	}
	vector<int> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		rev[p[i]] = i;
	}
	for(int i=1;i<n;i++) {
		gph[par[i]].push_back(i);
		// let's not shuffle edge endpoints, it's just annoyance
		edges.push_back({p[par[i]], p[i]});
	}
	dfs(0);
	double B = 0;
	double fact_log2 = 0;
	for(int i=n-1;i>0;i--) {
	    cnt[i]+=cnt[i+1];
	}
	for (int i = 1; i <= n; i++) {
	    for(int p:pv[i]) {
	        pcnt[p]+=cnt[i];
	    }
	}
	bool is2=true; //2의 거듭제곱 여부 저장
	for(int i=2;i<=n;i++) {
	    if (pcnt[i]>0) {
	        if (i!=2) {
	            is2=false;
	        }
	        B+=pcnt[i]*log2(i);
	    }
	    assert(pcnt[i]>=0);
	}
	int opt;
	if (is2) {
	    if (n>=2) {
	        opt=pcnt[2];
	    }
	    else {
	        opt=0;
	    }
	}
	else {
	    opt=(int)ceil(B+0.000001);
	}
	// BUT we MUST shuffle edge orders
	shuffle(all(edges), rng);
	vector<int> U;
	vector<int> V;
	for(int i=0;i<edges.size();i++) {
	    U.push_back(edges[i][0]);
	    V.push_back(edges[i][1]);
	}
	cmpcnt = 0;
	vector<int> res = recover(n, U, V);
	ensure(res.size() == n, "Wrong Answer [5]");
	for(int i = 0;i < n; i++) {
	    ensure(res[p[i]]==i, "Wrong Answer [4]");
	}
	ensure(cmpcnt<=20*opt,"Wrong Answer [3]");
    if (opt==0) {
        return;
    }
	double k=((double)cmpcnt)/opt;
	if (k<=1.4) {
	    
	}
	else if (k<=1.5) {
	    sc=min(sc,((1.5-k)/0.1)*10+80);
	}
	else if (k<=2.5) {
	    sc=min(sc,((2.5-k)/1)*20+60);
	}
	else if (k<=8) {
	    sc=min(sc,((8-k)/5.5)*50+10);
	}
	else {
	    sc=min(sc,((20-k)/12.0)*5+5);
	}
}

}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin>>s;
	ensure(s==input_secret,"input secret wrong?");
	int t;
	cin>>t;
	sc = 100;
	for(int i=0;i<t;i++) {
	    Go();
	}
	cout << output_secret << "\n";
	cout << sc << endl;
}
